Subject: git gc logs to standard error

From: Richard Rossel <[email-masked]>
Date: Mon, 14 Dec 2009 11:45:15 -0300

Hi,
I have a question related to the output of git gc logs. Let me explain,

I have a git commands in crontab (for redmine purpose) doing this stuff:
' git fetch -q origin && git reset -q --soft refs/remotes/origin/master '
for each project.

The problem is that am getting mail from crontab each time that somebody
do a push to the central server. Its really annoying. I try to avoid 
those messages
redirecting the standard output with no results, then adding a quiet 
option  and no results.
This is the kind of mails that am receiving:

remote: Counting objects: 6, done.
remote: Compressing objects:  25% (1/4)
remote: Compressing objects:  50% (2/4)
remote: Compressing objects:  75% (3/4        )remote:
remote: Compressing objects: 100% (4/4)
remote: Compressing objects: 100% (4/4), done.
remote: Total 4 (delta 2), reused 0 (delta 0)
 From git@boss:drivings
   0f35f06..5bc8866  master     -> origin/master

Then I realized that the message is git gc logs looks like, so I did:

$ git gc
Counting objects: 51, done.
Delta compression using up to 2 threads.
Compressing objects: 100% (35/35), done.
Writing objects: 100% (51/51), done.
Total 51 (delta 12), reused 51 (delta 12)

The message are pretty similar, so I sent the logs to dev/null but:

$ git gc >/dev/null
Counting objects: 51, done.
Delta compression using up to 2 threads.
Compressing objects: 100% (35/35), done.
Writing objects: 100% (51/51), done.
Total 51 (delta 12), reused 51 (delta 12)

I realized that the message are sent to standard error,
so the question is why is the reason to do that?

The quick solution to my problem of annoying mails is send the output 
error to /dev/null
but what happens when an error really occur, there will be no message to 
alert me.

thanks for your help

saludos.-

--
Richard Rossel
Software Engineer at Airsage Inc.
Valparaiso - Chile